###################################################
### chunk number 1: 
###################################################
library(sampling)
ps.options(pointsize=12)
options(width=60)


###################################################
### chunk number 2: calib1
###################################################
data=rbind(matrix(rep("nc",165),165,1,byrow=TRUE),matrix(rep("sc",70),70,1,byrow=TRUE))
data=cbind.data.frame(data,c(rep(1,100), rep(2,50), rep(3,15), rep(1,30),rep(2,40)),1000*runif(235))
sex=runif(nrow(data))
for(i in 1:length(sex))
 if(sex[i]<0.3)  sex[i]=1 else sex[i]=2
data=cbind.data.frame(data,sex)
names(data)=c("state","region","income","sex")




###################################################
### chunk number 3: calib2
###################################################
table(data$state)




###################################################
### chunk number 4: calib3
###################################################
s=strata(data,c("state"),size=c(25,10), method="srswor")



###################################################
### chunk number 5: calib31
###################################################
s=getdata(data,s)



###################################################
### chunk number 6: calib3
###################################################
status=runif(nrow(s))
for(i in 1:length(status))
 if(status[i]<0.3) status[i]=0 else status[i]=1
s=cbind.data.frame(s,status) 



###################################################
### chunk number 7: calib4
###################################################
s=rhg_strata(s,selection="region")




###################################################
### chunk number 8: calib5
###################################################
sr=s[s$status==1,]



###################################################
### chunk number 9: calib6
###################################################
X=matrix(0,nrow=nrow(data),ncol=5)
for(i in 1:nrow(data))
  {if(data$sex[i]==1) X[i,1]=1
   if(data$sex[i]==2) X[i,2]=1
   if(data$region[i]==1) X[i,3]=1
   if(data$region[i]==2) X[i,4]=1
   if(data$region[i]==3) X[i,5]=1
   }



###################################################
### chunk number 10: calib7
###################################################
total=c(t(rep(1,nrow(data)))%*%X)




###################################################
### chunk number 11: calib8
###################################################
Xs=matrix(0,nrow=nrow(sr),ncol=5)
for(i in 1:nrow(sr))
  {if(sr$sex[i]==1) Xs[i,1]=1
   if(sr$sex[i]==2) Xs[i,2]=1
   if(sr$region[i]==1) Xs[i,3]=1
   if(sr$region[i]==2) Xs[i,4]=1
   if(sr$region[i]==3) Xs[i,5]=1
   }




###################################################
### chunk number 12: calib9
###################################################
d=1/(sr$Prob*sr$prob_resp)



###################################################
### chunk number 13: calib10
###################################################
g=calib(Xs,d,total,method="linear")



###################################################
### chunk number 14: calib11
###################################################
checkcalibration(Xs,d,total,g)


###################################################
### chunk number 15:  eval=FALSE
###################################################
## data=rbind(matrix(rep("nc",165),165,1,byrow=TRUE),matrix(rep("sc",70),70,1,byrow=TRUE))
## data=cbind.data.frame(data,c(rep(1,100), rep(2,50), rep(3,15), rep(1,30),rep(2,40)),1000*runif(235))
## sex=runif(nrow(data))
## for(i in 1:length(sex))
##  if(sex[i]<0.3)  sex[i]=1 else sex[i]=2
## data=cbind.data.frame(data,sex)
## names(data)=c("state","region","income","sex")
## 
## 
## table(data$state)
## 
## 
## status=runif(nrow(s))
## for(i in 1:length(status))
##  if(status[i]<0.3) status[i]=0 else status[i]=1
## s=cbind.data.frame(s,status) 
## 
## s=getdata(data,s)
## 
## s=rhg_strata(s,selection="region")
## 
## 
## sr=s[s$status==1,]
## 
## X=matrix(0,nrow=nrow(data),ncol=5)
## for(i in 1:nrow(data))
##   {if(data$sex[i]==1) X[i,1]=1
##    if(data$sex[i]==2) X[i,2]=1
##    if(data$region[i]==1) X[i,3]=1
##    if(data$region[i]==2) X[i,4]=1
##    if(data$region[i]==3) X[i,5]=1
##    }
## 
## total=c(t(rep(1,nrow(data)))%*%X)
## 
## 
## Xs=matrix(0,nrow=nrow(sr),ncol=5)
## for(i in 1:nrow(sr))
##   {if(sr$sex[i]==1) Xs[i,1]=1
##    if(sr$sex[i]==2) Xs[i,2]=1
##    if(sr$region[i]==1) Xs[i,3]=1
##    if(sr$region[i]==2) Xs[i,4]=1
##    if(sr$region[i]==3) Xs[i,5]=1
##    }
## 
## 
## d=1/(sr$Prob*sr$prob_resp)
## 
## g=calib(Xs,d,total,method="linear")
## 
## 
## sampling.newpage()
## 


###################################################
### chunk number 16: ex1
###################################################
X=cbind(c(rep(1,50),rep(0,50)),c(rep(0,50),rep(1,50)),1:100)
# vector of population totals
total=apply(X,2,"sum")
Z=150:249 
# the variable of interest
Y=5*Z*(rnorm(100,0,1/3)+apply(X,1,"sum"))
# inclusion probabilities
pik=inclusionprobabilities(Z,20)
# joint inclusion probabilities 
pikl=UPtillepi2(pik)
# number of simulations; let nsim=10000 for an accurate result
nsim=10
c1=c2=c3=c4=c5=numeric(nsim)
for(i in 1:nsim)
{
# draws a sample
s=UPtille(pik)
# computes the inclusion prob. for the sample
piks=pik[s==1]
# the sample matrix of auxiliary information
Xs=X[s==1,]
# computes the g-weights
g=calib(Xs,d=1/piks,total,method="linear")
# computes the variable of interest in the sample
Ys=Y[s==1]
# computes the joint inclusion prob. for the sample
pikls=pikl[s==1,s==1]
# computes the calibration estimator and its variance estimation
cc=calibev(Ys,Xs,total,pikls,d=1/piks,g,with=FALSE,EPS=1e-6)
c1[i]=cc$calest
c2[i]=cc$evar
# computes the variance estimator of the calibration estimator (second method)
c3[i]=varest(Ys,Xs,pik=piks,w=g/piks)
# computes the variance estimator of the the Horvitz-Thompson estimator
c4[i]=varest(Ys=Ys,pik=piks) 
# computes the Horvitz-Thompson estimator
c5[i]=HTestimator(Ys,piks)
}
cat("the population total:",sum(Y),"\n")
cat("the mean under simulations of the calibration estimator:", mean(c1),"\n")
cat("for the calibration estimator:\n")
cat("the relative bias of the variance estimator using calibev function:",(mean(c2)-sum(Y))/sd(c2),"\n")
cat("MSE of the previous estimator:", var(c2)+(mean(c2)-sum(Y))^2,"\n")
cat("the relative bias of the variance estimator using varest function:", (mean(c3)-sum(Y))/sd(c3),"\n")
cat("MSE of the previous estimator:", var(c3)+(mean(c3)-sum(Y))^2,"\n")
cat("the mean under simulations of the Horvitz-Thompson estimator:", mean(c5),"\n")
cat("the mean under simulations of the variance estimator of the H-T estimator:", mean(c4),"\n")
# computes the variance of the Horvitz-Thompson estimator
N=length(Y)
delta=matrix(0,N,N)
for(k in 1:N)
  for(l in 1:N)
  if(k!=l) delta[k,l]=pikl[k,l]-pik[k]*pik[l]
diag(delta)=pik*(1-pik)
varHT=0
for(k in 1:N)
  for(l in 1:N) varHT=varHT+Y[k]*Y[l]*delta[k,l]/(pik[k]*pik[l])
cat("the variance of the Horvitz-Thompson estimator:", varHT, "\n")


###################################################
### chunk number 17:  eval=FALSE
###################################################
## X=cbind(c(rep(1,50),rep(0,50)),c(rep(0,50),rep(1,50)),1:100)
## # vector of population totals
## total=apply(X,2,"sum")
## Z=150:249 
## # the variable of interest
## Y=5*Z*(rnorm(100,0,1/3)+apply(X,1,"sum"))
## # inclusion probabilities
## pik=inclusionprobabilities(Z,20)
## # joint inclusion probabilities 
## pikl=UPtillepi2(pik)
## # number of simulations; let nsim=10000 for an accurate result
## nsim=10
## c1=c2=c3=c4=c5=numeric(nsim)
## for(i in 1:nsim)
## {
## # draws a sample
## s=UPtille(pik)
## # computes the inclusion prob. for the sample
## piks=pik[s==1]
## # the sample matrix of auxiliary information
## Xs=X[s==1,]
## # computes the g-weights
## g=calib(Xs,d=1/piks,total,method="linear")
## # computes the variable of interest in the sample
## Ys=Y[s==1]
## # computes the joint inclusion prob. for the sample
## pikls=pikl[s==1,s==1]
## # computes the calibration estimator and its variance estimation
## cc=calibev(Ys,Xs,total,pikls,d=1/piks,g,with=FALSE,EPS=1e-6)
## c1[i]=cc$calest
## c2[i]=cc$evar
## # computes the variance estimator of the calibration estimator (second method)
## c3[i]=varest(Ys,Xs,pik=piks,w=g/piks)
## # computes the variance estimator of the the Horvitz-Thompson estimator
## c4[i]=varest(Ys=Ys,pik=piks) 
## # computes the Horvitz-Thompson estimator
## c5[i]=HTestimator(Ys,piks)
## }
## cat("the population total:",sum(Y),"\n")
## cat("the mean under simulations of the calibration estimator:", mean(c1),"\n")
## cat("for the calibration estimator:\n")
## cat("the relative bias of the variance estimator using calibev function:",(mean(c2)-sum(Y))/sd(c2),"\n")
## cat("MSE of the previous estimator:", var(c2)+(mean(c2)-sum(Y))^2,"\n")
## cat("the relative bias of the variance estimator using varest function:", (mean(c3)-sum(Y))/sd(c3),"\n")
## cat("MSE of the previous estimator:", var(c3)+(mean(c3)-sum(Y))^2,"\n")
## cat("the mean under simulations of the Horvitz-Thompson estimator:", mean(c5),"\n")
## cat("the mean under simulations of the variance estimator of the H-T estimator:", mean(c4),"\n")
## # computes the variance of the Horvitz-Thompson estimator
## N=length(Y)
## delta=matrix(0,N,N)
## for(k in 1:N)
##   for(l in 1:N)
##   if(k!=l) delta[k,l]=pikl[k,l]-pik[k]*pik[l]
## diag(delta)=pik*(1-pik)
## varHT=0
## for(k in 1:N)
##   for(l in 1:N) varHT=varHT+Y[k]*Y[l]*delta[k,l]/(pik[k]*pik[l])
## cat("the variance of the Horvitz-Thompson estimator:", varHT, "\n")
## 
## sampling.newpage()
## 


